(* Proof Accelerator library (http://proofos.sf.net/accel/)
 * Copyright (C) 2005  The Regents of the University of California
 * Author: Adam Chlipala
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *)

(** Implementing Coq's nat type conservatively with [Big_int.big_int] *)

exception Overflow

type nat = Big_int.big_int

val two : nat

val succ : nat -> nat
val pred : nat -> nat

val plus : nat -> nat -> nat
val minus : nat -> nat -> nat
val times : nat -> nat -> nat

val eq_nat_dec : nat -> nat -> bool

val of_int : int -> nat
val of_string : string -> nat
