(* Proof Accelerator library (http://proofos.sf.net/accel/)
 * Copyright (C) 2005  The Regents of the University of California
 * Author: Adam Chlipala
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *)

(** Implementing Coq's Z type conservatively with [int] *)

type z = Big_int.big_int

val xO : z -> z
val xI : z -> z

val plus : z -> z -> z
val minus : z -> z -> z
val times : z -> z -> z
val div : z -> z -> z
val neg : z -> z
