open Format
open X86Print

let pp_apc fmt = function
    ApcConst i -> pp_addr fmt i
  | ApcRet -> pp_print_string fmt "RET"

let pp_astate fmt abs =
  fprintf fmt "   Pc = %a@\n" pp_apc (GenericTypes.aPc abs);
  fprintf fmt " Regs = %a@\n" (Reg32Map.print pp_reg32 pp_ty) (GenericTypes.aRegs abs);
  fprintf fmt "Ssize = %s@\n" (Big_int.string_of_big_int (GenericTypes.aStackSize abs));
  fprintf fmt "Slots = %a@\n" (NatMap.print pp_print_big_int pp_ty) (GenericTypes.aStackSlots abs);
  Param.pp_astat fmt (GenericTypes.aCustom abs);
  fprintf fmt "@?"
