open Format
open X86Print

let pp_apc fmt = function
    ApcConst i -> pp_addr fmt i
  | ApcRet -> pp_print_string fmt "RET"

let pp_astate fmt abs =
  fprintf fmt "   Pc = %a@\n" pp_apc abs.aPc;
  fprintf fmt " Regs = %a@\n" (Reg32Map.print pp_reg32 pp_ty) abs.aRegs;
  fprintf fmt "Ssize = %s@\n" (Big_int.string_of_big_int abs.aStackSize);
  fprintf fmt "Slots = %a@\n@?" (NatMap.print pp_print_big_int pp_ty) abs.aStackSlots
