# Copyright (c) 2005, Regents of the University of California
# All rights reserved.
#
# Author: Adam Chlipala
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# - Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
# - Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# - Neither the name of the University of California, Berkeley nor the names of
#   its contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
	
# Adapted from http://osdever.net/bkerndev/Docs/basickernel.htm

.section .meta
kernel_meta:
.section .text
		
.globl start

start:
	jmp real_start

.int	regions

0:
.section .meta
	.int 2, 0b, 8186, 0
.section .text
real_start:
	movl $0x01001ffe, %esp
0:
.section .meta
	.int 2, 0b, 8186, 1, 4, 2, 0, 0
.section .text	
	call main
0:
.section .meta
	.int 2, 0b, 8186, 1, 4, 2, 0, 0
.section .text
	jmp 0b
code_finished:

.section .meta
	.int 0
.section .text
	
.section .regions
.string	"main"
.string "start"
.int start
.string ""
.int start, code_finished
.int 0, 0
.int 0, 0
.int kernel_meta
.section .text

.align 4
mboot:
	# GRUB Multiboot header
	.int 0x1BADB002
	.int (1<<0 | 1<<1 | 1<<16)
	.int (-(0x1BADB002 + (1<<0 | 1<<1 | 1<<16)))
	    
	# AOUT kludge - must be physical addresses.
	.int mboot, code, bss, end, start
