/* Copyright (c) 2005, Regents of the University of California
 * All rights reserved.
 *
 * Author: Adam Chlipala
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name of the University of California, Berkeley nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

typedef struct cell {
  char ch;
  unsigned fg : 4;
  unsigned bg : 4;
  } __attribute__((__packed__))cell;

#define ROWS 25
#define COLS 80

#define TEXTMEM  (*(cell (*)[ROWS][COLS])0xB8000)

#define EAX "0"
#define ECX "1"
#define EDX "2"
#define EBX "3"
#define ESP "4"
#define EBP "5"
#define ESI "6"
#define EDI "7"

#define TOP "0"
#define CONST(n) "1, " #n
#define STACK(n) "2, " #n
#define OLDEBP "3"
#define RETPTR "4"
#define CUSTOM(n) "5, " n

#define BEGIN_FUNC(ss) __asm__("0:;.section .cutpoints; .int 1, 0b, " #ss)
#define END_FUNC() __asm__(".int 0; .section .text")

#define BEGIN_CUTPOINT(ss) __asm__("0:;.section .cutpoints; .int 2, 0b, " #ss)
#define END_CUTPOINT() __asm__(".int 0; .section .text")

#define REG_TYPE(r, t) __asm__(".int 1, " r ", " t)
#define STACK_TYPE(r, t) __asm__(".int 2, " #r ", " t)
