/* Copyright (c) 2005, Regents of the University of California
 * All rights reserved.
 *
 * Author: Adam Chlipala
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name of the University of California, Berkeley nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "intptr.h"

BEGIN_FUNC(100);
STACK_TYPE(4, NNPTR);
END_FUNC();
int read_nnptr(int *p) {
  return *p;
}

BEGIN_FUNC(100);
STACK_TYPE(8, NNPTR);
STACK_TYPE(4, TOP);
END_FUNC();
void write_nnptr(int *p, int v) {
  *p = v;
}

BEGIN_FUNC(100);
STACK_TYPE(4, PTR);
END_FUNC();
int read_ptr(int *p) {
  int ret;

  if (p) {
    ret = *p;
  }
  else {
    BEGIN_CUTPOINT(50);
    REG_TYPE(ESP, STACK(16));
    REG_TYPE(EBP, STACK(12));
    STACK_TYPE(8, RETPTR);
    STACK_TYPE(12, OLDEBP);
    END_CUTPOINT();
    ret = -1;
  }

  BEGIN_CUTPOINT(50);
  REG_TYPE(ESP, STACK(16));
  REG_TYPE(EBP, STACK(12));
  STACK_TYPE(8, RETPTR);
  STACK_TYPE(12, OLDEBP);
  END_CUTPOINT();
  return ret;
}

BEGIN_FUNC(8186);
END_FUNC();
int main() {
  static int n, m;

  write_nnptr(&n, 346);
  return read_nnptr(&n) + read_ptr(0) + read_ptr(&m);
}
