/* Copyright (c) 2006, Regents of the University of California
 * All rights reserved.
 *
 * Author: Adam Chlipala
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name of the University of California, Berkeley nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "mtypes.h"

struct intListNode;

typedef struct intList {
  int tag;
  struct intListNode {
    int data;
    struct intList *next;
  } *node;
} *intList;

#define INTLIST_CUST REC(0, SUM(ANYTHING, PRODUCT(CONS(ANYTHING, CONS(VAR(0), NIL)))))
#define INTLIST CUSTOM(INTLIST_CUST)
#define INTLIST_UNROLLED CUSTOM(SUM(ANYTHING, PRODUCT(CONS(ANYTHING, CONS(INTLIST_CUST, NIL)))))

BEGIN_FUNC(100);
STACK_TYPE(4, INTLIST);
REG_TYPE(EAX, INTLIST);
END_FUNC();
intList prev(intList ls) {
  intList ret;
  
  if (ls->tag == 0) {
    BEGIN_CUTPOINT(50);
    REG_TYPE(EBP, STACK(12));
    REG_TYPE(ESP, STACK(12));
    REG_TYPE(EAX, INTLIST);
    STACK_TYPE(8, RETPTR);
    STACK_TYPE(12, OLDEBP);
    END_CUTPOINT();
    ret = ls;
  }
  else {
    BEGIN_CUTPOINT(50);
    REG_TYPE(EBP, STACK(12));
    REG_TYPE(ESP, STACK(12));
    REG_TYPE(EAX, CUSTOM(PRODUCT(CONS(CONSTANT(1), CONS(PRODUCT(CONS(ANYTHING, CONS(INTLIST_CUST, NIL))), NIL)))));
    STACK_TYPE(8, RETPTR);
    STACK_TYPE(12, OLDEBP);
    END_CUTPOINT();
    ret = ls->node->next;
  }

  BEGIN_CUTPOINT(50);
  REG_TYPE(EBP, STACK(12));
  REG_TYPE(ESP, STACK(12));
  REG_TYPE(EAX, INTLIST);
  STACK_TYPE(8, RETPTR);
  STACK_TYPE(12, OLDEBP);
  END_CUTPOINT();
  return ret;
}

BEGIN_FUNC(100);
STACK_TYPE(4, INTLIST);
END_FUNC();
void bump(intList ls) {
  for (;;) {
    if (ls->tag == 0) {
      BEGIN_CUTPOINT(50);
      REG_TYPE(EBP, STACK(12));
      REG_TYPE(ESP, STACK(12));
      STACK_TYPE(8, RETPTR);
      STACK_TYPE(12, OLDEBP);
      END_CUTPOINT();
      return;
    }

    BEGIN_CUTPOINT(50);
    REG_TYPE(EBP, STACK(12));
    REG_TYPE(ESP, STACK(12));
    REG_TYPE(EDX, CUSTOM(PRODUCT(CONS(CONSTANT(1), CONS(PRODUCT(CONS(ANYTHING, CONS(INTLIST_CUST, NIL))), NIL)))));
    STACK_TYPE(8, RETPTR);
    STACK_TYPE(12, OLDEBP);
    END_CUTPOINT();
    ++ls->node->data;
    ls = ls->node->next;
  }
}

BEGIN_FUNC(100);
END_FUNC();
int main() {
  return 0;
}
