/* Copyright (c) 2006, Regents of the University of California
 * All rights reserved.
 *
 * Author: Adam Chlipala
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name of the University of California, Berkeley nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "mtypes.h"

#define INTPTR_CUST PRODUCT(CONS(ANYTHING, NIL))
#define INTPTR CUSTOM(INTPTR_CUST)

typedef struct {
  int x, y;
} intPair;

#define INTPAIR_CUST PRODUCT(CONS(ANYTHING, CONS(ANYTHING, NIL)))
#define INTPAIR CUSTOM(INTPAIR_CUST)

typedef struct {
  int *x, *y;
} intPtrPair;

#define INTPTRPAIR_CUST PRODUCT(CONS(INTPTR_CUST, CONS(INTPTR_CUST, NIL)))
#define INTPTRPAIR CUSTOM(INTPTRPAIR_CUST)

typedef struct {
  int x, *y;
} mixedPair;

#define MIXEDPAIR_CUST PRODUCT(CONS(ANYTHING, CONS(INTPTR_CUST, NIL)))
#define MIXEDPAIR CUSTOM(MIXEDPAIR_CUST)

BEGIN_FUNC(100);
STACK_TYPE(4, INTPAIR);
END_FUNC();
int intPair_fst(intPair *p) {
  return p->x;
}

BEGIN_FUNC(100);
STACK_TYPE(4, INTPAIR);
END_FUNC();
int intPair_snd(intPair *p) {
  return p->y;
}

BEGIN_FUNC(100);
STACK_TYPE(12, INTPAIR);
STACK_TYPE(8, TOP);
STACK_TYPE(4, TOP);
END_FUNC();
void intPair_write(intPair *p, int x, int y) {
  p->x = x;
  p->y = y;
}

BEGIN_FUNC(100);
STACK_TYPE(4, INTPTRPAIR);
REG_TYPE(EAX, INTPTR);
END_FUNC();
int* intPtrPair_fst(intPtrPair *p) {
  return p->x;
}

BEGIN_FUNC(100);
STACK_TYPE(4, INTPTRPAIR);
REG_TYPE(EAX, INTPTR);
END_FUNC();
int* intPtrPair_snd(intPtrPair *p) {
  return p->y;
}

BEGIN_FUNC(100);
STACK_TYPE(12, INTPTRPAIR);
STACK_TYPE(8, INTPTR);
STACK_TYPE(4, INTPTR);
END_FUNC();
void intPtrPair_write(intPtrPair *p, int *x, int *y) {
  p->x = x;
  p->y = y;
}

BEGIN_FUNC(100);
STACK_TYPE(12, MIXEDPAIR);
STACK_TYPE(8, TOP);
STACK_TYPE(4, INTPTR);
END_FUNC();
void mixedPair_write(mixedPair *p, int x, int *y) {
  p->x = x;
  p->y = y;
}

BEGIN_FUNC(100);
END_FUNC();
int main() {
  return 0;
}
