/* Copyright (c) 2006, Regents of the University of California
 * All rights reserved.
 *
 * Author: Adam Chlipala
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name of the University of California, Berkeley nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "mtypes.h"

#define INTPTR_CUST PRODUCT(CONS(ANYTHING, NIL))
#define INTPTR CUSTOM(INTPTR_CUST)

#define INTPTRPTR_CUST PRODUCT(CONS(INTPTR_CUST, NIL))
#define INTPTRPTR CUSTOM(INTPTRPTR_CUST)

typedef struct {
  int tag;
  union {
    int x, y;
  } value;
} intSum;

#define INTSUM_CUST SUM(ANYTHING, ANYTHING)
#define INTSUM CUSTOM(INTSUM_CUST)

typedef struct {
  int tag;
  union {
    int *ptr1, **ptr2;
  } value;
} riskySum;

#define RISKYSUM_CUST SUM(INTPTR_CUST, INTPTRPTR_CUST)
#define RISKYSUM CUSTOM(RISKYSUM_CUST)

BEGIN_FUNC(100);
STACK_TYPE(8, RISKYSUM);
STACK_TYPE(4, TOP);
END_FUNC();
void riskySum_whichever(riskySum *s, int v) {
  if (s->tag == 0)
    *s->value.ptr1 = v;
  else {
    BEGIN_CUTPOINT(50);
    REG_TYPE(EBP, STACK(16));
    REG_TYPE(ESP, STACK(16));
    REG_TYPE(EAX, CUSTOM(PRODUCT(CONS(CONSTANT(1), CONS(INTPTRPTR_CUST, NIL)))));
    STACK_TYPE(12, RETPTR);
    STACK_TYPE(16, OLDEBP);
    END_CUTPOINT();
    **s->value.ptr2 = v;
  }

  BEGIN_CUTPOINT(50);
  REG_TYPE(EBP, STACK(16));
  REG_TYPE(ESP, STACK(16));
  STACK_TYPE(12, RETPTR);
  STACK_TYPE(16, OLDEBP);
  END_CUTPOINT();
}

BEGIN_FUNC(100);
END_FUNC();
int main() {
  return 0;
}
